
import java.net.*;
import kotlinx.coroutines.*
import java.io.*;
import kotlin.concurrent.thread
import java.io.File



//series, id, x, ,y, score
class Player(val id:Int, val name:String, public var x:Int, public var y:Int, val score:Int){

}
class Game(){
    var series:Int=0
    val players:MutableList<Player> = mutableListOf()
    fun update(line:String){
        val split = line.split(",")
        val series = split[0].toInt()
        if (series>this.series) this.series=series;
        if (series<this.series){return}
        //continue only of we get newest series
        if (!players.map { it.id }.contains(split[1].toInt())){
            players.add(Player(split[1].toInt(),"",split[2].toInt(),split[3].toInt(),split[4].toInt()))
        }else{
            val player:Player = players.filter{ it.id==split[1].toInt()}[0]
            player.x= split[2].toInt(); player.y=split[3].toInt()
        }
    }
    fun draw(){

        var str ="";
        for (i in 0..50){
            for (j in 0..50){
                players.forEach{
                    if (it.x == i && it.y==j){
                        str+="x"
                    }
                    else{
                        str+=" "
                    }
                }
            }
            str+="\n"
        }
        println("\u001Bc")
        print(str)
    }
}
fun main() {
        val game = Game()
        println("hello");
        val a = ClientConnection();
        a.startConnection("192.168.0.136", 1234);
        a.sendMessage("a");
        while(true) {
            val line = readLine()!!
            if (listOf("d", "u", "l", "r", "o", "f").contains(line)) {
                if (line=="f"){

                    val file = File(readLine())
                    val buffer = ByteArray(512);

                    val fileStream = file.inputStream()
                    var count=1;
                   a.sendMessage("f");
                    while (count>0) {
                        count = fileStream.read(buffer)
                        if (count>0)
                        a.getOutputStream().write(buffer, 0, count)
                    }

                    continue;
                }
                a.sendMessage(line)
                var rsp: String = ""
                while (rsp != "end") {
                    rsp = a.readMessage()
                    println(rsp);
                    if (rsp != "end")
                        game.update(rsp)
                }
               // game.draw()
            }

        }
        readLine()
    }
